unit RichEditDllUnit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, OleCtrls, ExtCtrls, Buttons;

type
  TDllForm = class(TForm)
    Panel2: TPanel;
    RichEdit1: TRichEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  DllForm: TDllForm;

{$ifdef WIN32}
procedure ZeigDich;
procedure Maximieren;
procedure Minimieren;
procedure Normal;
procedure DLLFormWidth(L, T, B: Integer);
procedure DLLFormHeight(T, L, H: Integer);
function  StringEinsetzen(S: WideString): WideString;
procedure SchriftArtNeu(SchrN: WideString; FntSize: Integer; FntColor: TColor; FntStyle: TFontStyles);
procedure DateiSpeichern(SName: WideString);
procedure DateiLaden(LName: WideString);
procedure Sichtbar(Zustand: WideString);
procedure ZeilenUmbruch(Zustand: WideString);
procedure ScrollBalken(Zustand: WideString);
procedure RichEditPrint(DokName: WideString);
{$else}
procedure ZeigDich; export;
procedure Maximieren; export;
procedure Minimieren; export;
procedure Normal; export;
procedure DLLFormWidth(L, T, B: Integer); export;
procedure DLLFormHeight(T, L, H: Integer); export;
function  StringEinsetzen(S: WideString): WideString; export;
procedure SchriftArtNeu(SchrN: WideString; FntSize: Integer; FntColor: TColor; FntStyle: TFontStyles); export;
procedure DateiSpeichern(SName: WideString); export;
procedure DateiLaden(LName: WideString); export;
procedure Sichtbar(Zustand: WideString); export;
procedure ZeilenUmbruch(Zustand: WideString); export;
procedure ScrollBalken(Zustand: WideString); export;
procedure RichEditPrint(DokName: WideString); export;
{$endif}

implementation

{$R *.DFM}


Procedure ZeigDich;
begin
  DllForm := TDllForm.Create(Application);
  DllForm.Show;
end;

procedure Maximieren;
begin
  DllForm.WindowState := wsMaximized;
end;

procedure Minimieren;
begin
  DllForm.WindowState := wsMinimized;
end;

procedure Normal;
begin
  DllForm.WindowState := wsNormal;
end;

procedure DLLFormWidth(L, T, B: Integer);
begin
  DllForm.Top := T;
  DllForm.Left := L;
  DllForm.Width := B;
end;

procedure DLLFormHeight(T, L, H: Integer);
begin
  DllForm.Left := L;
  DllForm.Top := T;
  DllForm.Height := H;
end;

function  StringEinsetzen(S: WideString): WideString;
begin
  DllForm.RichEdit1.Lines.Add(S);
  StringEinsetzen := 'String wurde bergeben';
end;

procedure SchriftArtNeu(SchrN: WideString; FntSize: Integer; FntColor: TColor; FntStyle: TFontStyles);
begin
  // DllForm.RichEdit1.Font.Name := SchrN;
  DllForm.RichEdit1.SelAttributes.Name := SchrN;
  DllForm.RichEdit1.SelAttributes.Size := FntSize;
  DllForm.RichEdit1.SelAttributes.Color := FntColor;
  DllForm.RichEdit1.SelAttributes.Style := FntStyle;
end;

procedure DateiSpeichern(SName: WideString);
begin
  DllForm.RichEdit1.Lines.SaveToFile(SName);
end;

procedure DateiLaden(LName: WideString);
begin
  DllForm.RichEdit1.Lines.LoadFromFile(LName);
end;

procedure Sichtbar(Zustand: WideString);
begin
  If Zustand = 'True' Then
    begin
      DllForm.Visible := True;
    end;
  If Zustand = 'False' Then
    begin
      DllForm.Visible := False;
    end;
end;

procedure ZeilenUmbruch(Zustand: WideString);
begin
  If Zustand = 'True' Then
    begin
      DllForm.RichEdit1.WordWrap := True;
    end;
  If Zustand = 'False' Then
    begin
      DllForm.RichEdit1.WordWrap := False;
    end;
end;

procedure ScrollBalken(Zustand: WideString);
begin
  If Zustand = 'True' Then
    begin
      DllForm.RichEdit1.ScrollBars := ssBoth;
    end;
  If Zustand = 'False' Then
    begin
      DllForm.RichEdit1.ScrollBars := ssNone;
    end;
end;

procedure RichEditPrint(DokName: WideString); export;
begin
  DllForm.RichEdit1.Print(DokName);
end;

procedure TDllForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DllForm.Release;
end;

end.
