unit RichEditDllUserUnit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, TypInfo, Forms, ExtCtrls,
  AvgLvlTree, LCLType, LCLProc, LCLIntf, LResources, GraphType, Graphics, Menus,
  ActnList, ClipBrd, Controls, Buttons, Windows, StdCtrls, Dialogs,
  PrintersDlgs;


type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Edit1: TEdit;
    FontDialog1: TFontDialog;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    SaveDialog1: TSaveDialog;
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure RichEditDllFormEinsetzen;
  end; 

var
  Form1: TForm1;
  aWnd : Hwnd;
  WPM : TWindowPlacement;

procedure ZeigDich; register;
procedure Maximieren; register;
procedure Minimieren; register;
procedure Normal; register;
function  StringEinsetzen(S: WideString): WideString; register;
procedure SchriftArtNeu(SchrN: WideString; FntSize: Integer; FntColor: TColor; FntStyle: TFontStyles); register;
procedure DateiSpeichern(SName: WideString); register;
procedure DateiLaden(LName: WideString); register;
procedure Sichtbar(Zustand: WideString); register;
procedure DLLFormWidth(L, T, B: Integer); register;
procedure DLLFormHeight(T, L, H: Integer); register;
procedure ZeilenUmbruch(Zustand: WideString); register;
procedure ScrollBalken(Zustand: WideString); register;
procedure RichEditPrint(DokName: WideString); register;


implementation

var
   FirstLoad, IstResize: Boolean;
   
procedure ZeigDich; register; external 'RichEditDll';
procedure Maximieren; register; external 'RichEditDll';
procedure Minimieren; register; external 'RichEditDll';
procedure Normal; register; external 'RichEditDll';
function  StringEinsetzen(S: WideString): WideString; register; external 'RichEditDll';
procedure SchriftArtNeu(SchrN: WideString; FntSize: Integer; FntColor: TColor; FntStyle: TFontStyles); register; external 'RichEditDll';
procedure DateiSpeichern(SName: WideString); register; external 'RichEditDll';
procedure DateiLaden(LName: WideString); register; external 'RichEditDll';
procedure Sichtbar(Zustand: WideString); register; external 'RichEditDll';
procedure DLLFormWidth(L, T, B: Integer); register; external 'RichEditDll';
procedure DLLFormHeight(T, L, H: Integer); register; external 'RichEditDll';
procedure ZeilenUmbruch(Zustand: WideString); register; external 'RichEditDll';
procedure ScrollBalken(Zustand: WideString); register; external 'RichEditDll';
procedure RichEditPrint(DokName: WideString); register; external 'RichEditDll';




{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  ZeigDich;
  RichEditDllFormEinsetzen;
  FirstLoad := True;
  IstResize := False;
  Button1.Enabled := False;
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  OpenFName: WideString;
  
begin
  If FirstLoad = False Then Exit;
  If OpenDialog1.Execute Then
     begin
       OpenFName := OpenDialog1.FileName;
       DateiLaden(OpenFName);
     end;
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  SaveFName: WideString;
begin
  If FirstLoad = False Then Exit;
  If SaveDialog1.Execute Then
     begin
       SaveFName := SaveDialog1.FileName;
       DateiSpeichern(SaveFName);
     end;
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  If Button12.Caption = 'Zeilenumbruch Aus' Then
    begin
      ZeilenUmbruch('False');
      Button12.Caption := 'Zeilenumbruch Ein';
      Exit;
    end;
  If Button12.Caption = 'Zeilenumbruch Ein' Then
    begin
      ZeilenUmbruch('True');
      Button12.Caption := 'Zeilenumbruch Aus';
    end;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  If Button13.Caption = 'Scrollbalken Ein' Then
    begin
      ScrollBalken('True');
      Button13.Caption := 'Scrollbalken Aus';
      Exit;
    end;
  If Button13.Caption = 'Scrollbalken Aus' Then
    begin
      ScrollBalken('False');
      Button13.Caption := 'Scrollbalken Ein';
    end;
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  RichEditPrint('RichEditTest');
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Maximieren;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Minimieren;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Normal;
end;

procedure TForm1.RichEditDllFormEinsetzen;
function FindWindowByTitle(WindowTitle: string): Hwnd;
var
  NextHandle: Hwnd;
  NextTitle: array[0..260] of char;
begin
   // Get the first window
   NextHandle := GetWindow(Application.MainForm.Handle, GW_HWNDFIRST);
   while NextHandle > 0 do
   begin
     // retrieve its text
     GetWindowText(NextHandle, NextTitle, 255);
     if Pos(WindowTitle, StrPas(NextTitle)) <> 0 then
     begin
       Result := NextHandle;
       Exit;
     end
     else
     // Get the next window
     NextHandle := GetWindow(NextHandle, GW_HWNDNEXT);
   end;
   Result := 0;
end;

begin
  aWnd := FindWindowByTitle('RichEditDllForm');
  if aWnd <> 0 then
    begin
      Windows.SetParent(awnd,Form1.Panel2.Handle);
      SetWindowLong(awnd,GWL_STYLE,GetWindowLong(awnd,GWL_STYLE) AND NOT WS_CAPTION);
      WPM.Length:=SizeOf(WPM);
      GetWindowPlacement(awnd,@WPM);
      WPM.ShowCmd:=SW_ShowMaximized;
      WPM.rcNormalPosition:=Classes.Rect(0,0,Form1.Panel2.Width,Form1.Panel2.Height);
      SetWindowPlacement(awnd,@WPM);
    end;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
  DllFormWidth((0 - Panel2.Left) + 8, 0 - Form1.Top - 37, Panel2.Width);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  DllFormHeight((0 - Panel2.Top) + 8, 0 - (Form1.Left + Panel1.Width + 11), Panel2.Height);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Sichtbar('False');
  Minimieren;
  Maximieren;
  Sichtbar('True');
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  S: WideString;

begin
  If FirstLoad = False Then Exit;
  S := StringEinsetzen(Edit1.Text);
  Edit1.Text := S;
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  SchrName: WideString;
  FontSize: Integer;
  FontColor: TColor;
  FontStyle: TFontStyles;

begin
  If FirstLoad = False Then Exit;
  If FontDialog1.Execute Then
     begin
       SchrName := FontDialog1.Font.Name;
       FontSize := FontDialog1.Font.Size;
       FontColor := FontDialog1.Font.Color;
       FontStyle := FontDialog1.Font.Style;
       SchriftArtNeu(SchrName, FontSize, FontColor, FontStyle);
       Label1.Caption := SchrName;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   FirstLoad := False;
   IstResize := False;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  If FirstLoad = False Then Exit;
  IstResize := True;
  Sichtbar('False');
  Minimieren;
  Maximieren;
  Sichtbar('True');
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Button1.Click;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin

end;


initialization
  {$I RichEditDllUserUnit.lrs}

end.

